class Snowflake {
  DateTime get epoch => DateTime.fromMillisecondsSinceEpoch(1420070400000, isUtc: true);
  DateTime timestamp;
  int generation;
  int processId;
  int workerId;
  int userId;

  Snowflake (this.generation, this.timestamp, this.processId, this.workerId) {
    var ep = timestamp.millisecondsSinceEpoch - epoch.millisecondsSinceEpoch;

    var sflake = ep << 22;
    sflake |= (workerId % 32) << 17;
    sflake |= (processId % 32) << 12;
    sflake |= (generation % 4096);

    userId = sflake;
  }

  Snowflake.fromUserId(this.userId) {
    // Calculate shit here.
    var epochTime = userId >> 22;

    timestamp = DateTime.fromMillisecondsSinceEpoch(epochTime + epoch.millisecondsSinceEpoch);
    generation = userId >> 0 & 4095;
    processId = userId >> 12 & 31;
    workerId = userId >> 17 & 31;
  }
}
