import 'package:snowflake/snowflake.dart';
import 'package:test/test.dart';

void main() {
  group('A group of tests', () {
    Snowflake snowflake;
    Snowflake snowflakeReverse;

    setUp(() {
        snowflake = Snowflake(5, DateTime.fromMillisecondsSinceEpoch(1607897516000), 0, 1);
        snowflakeReverse = Snowflake.fromUserId(787804023947395077);
    });

    test('Test Getting User Id', () {
      expect(snowflake.userId, 787804023947395077);
    });
    test('Test Getting Timestamp from User Id', () {
       expect(snowflakeReverse.timestamp.millisecondsSinceEpoch, 1607897516000);
    });
  });
}
